## smlsharp 4.1.0

=== precompiled/Makefile ===
# auto-generated. DO NOT EDIT BY HAND.
PRECOMPILED_DIR=precompiled/$(PRECOMPILED_ARCH)
$(PRECOMPILED_DIR)/SQLConfig_mini.o: $(LLVM_PLUGIN) $(PRECOMPILED_DIR)/SQLConfig_mini.ll
	$(PRECOMPILE_LLC) -o $@ $(srcdir)/$(PRECOMPILED_DIR)/SQLConfig_mini.ll
$(PRECOMPILED_DIR)/General.o: $(LLVM_PLUGIN) $(PRECOMPILED_DIR)/General.ll
	$(PRECOMPILE_LLC) -o $@ $(srcdir)/$(PRECOMPILED_DIR)/General.ll
$(PRECOMPILED_DIR)/StringCvt.o: $(LLVM_PLUGIN) $(PRECOMPILED_DIR)/StringCvt.ll
	$(PRECOMPILE_LLC) -o $@ $(srcdir)/$(PRECOMPILED_DIR)/StringCvt.ll
$(PRECOMPILED_DIR)/List.o: $(LLVM_PLUGIN) $(PRECOMPILED_DIR)/List.ll
	$(PRECOMPILE_LLC) -o $@ $(srcdir)/$(PRECOMPILED_DIR)/List.ll
$(PRECOMPILED_DIR)/SMLSharp_ScanChar.o: $(LLVM_PLUGIN) $(PRECOMPILED_DIR)/SMLSharp_ScanChar.ll
	$(PRECOMPILE_LLC) -o $@ $(srcdir)/$(PRECOMPILED_DIR)/SMLSharp_ScanChar.ll
$(PRECOMPILED_DIR)/Char.o: $(LLVM_PLUGIN) $(PRECOMPILED_DIR)/Char.ll
	$(PRECOMPILE_LLC) -o $@ $(srcdir)/$(PRECOMPILED_DIR)/Char.ll
$(PRECOMPILED_DIR)/CharVector.o: $(LLVM_PLUGIN) $(PRECOMPILED_DIR)/CharVector.ll
	$(PRECOMPILE_LLC) -o $@ $(srcdir)/$(PRECOMPILED_DIR)/CharVector.ll
$(PRECOMPILED_DIR)/Substring.o: $(LLVM_PLUGIN) $(PRECOMPILED_DIR)/Substring.ll
	$(PRECOMPILE_LLC) -o $@ $(srcdir)/$(PRECOMPILED_DIR)/Substring.ll
$(PRECOMPILED_DIR)/String.o: $(LLVM_PLUGIN) $(PRECOMPILED_DIR)/String.ll
	$(PRECOMPILE_LLC) -o $@ $(srcdir)/$(PRECOMPILED_DIR)/String.ll
$(PRECOMPILED_DIR)/IntInf.o: $(LLVM_PLUGIN) $(PRECOMPILED_DIR)/IntInf.ll
	$(PRECOMPILE_LLC) -o $@ $(srcdir)/$(PRECOMPILED_DIR)/IntInf.ll
$(PRECOMPILED_DIR)/Int32.o: $(LLVM_PLUGIN) $(PRECOMPILED_DIR)/Int32.ll
	$(PRECOMPILE_LLC) -o $@ $(srcdir)/$(PRECOMPILED_DIR)/Int32.ll
$(PRECOMPILED_DIR)/SMLSharp_Runtime.o: $(LLVM_PLUGIN) $(PRECOMPILED_DIR)/SMLSharp_Runtime.ll
	$(PRECOMPILE_LLC) -o $@ $(srcdir)/$(PRECOMPILED_DIR)/SMLSharp_Runtime.ll
$(PRECOMPILED_DIR)/IEEEReal.o: $(LLVM_PLUGIN) $(PRECOMPILED_DIR)/IEEEReal.ll
	$(PRECOMPILE_LLC) -o $@ $(srcdir)/$(PRECOMPILED_DIR)/IEEEReal.ll
$(PRECOMPILED_DIR)/SMLSharp_RealClass.o: $(LLVM_PLUGIN) $(PRECOMPILED_DIR)/SMLSharp_RealClass.ll
	$(PRECOMPILE_LLC) -o $@ $(srcdir)/$(PRECOMPILED_DIR)/SMLSharp_RealClass.ll
$(PRECOMPILED_DIR)/Real64.o: $(LLVM_PLUGIN) $(PRECOMPILED_DIR)/Real64.ll
	$(PRECOMPILE_LLC) -o $@ $(srcdir)/$(PRECOMPILED_DIR)/Real64.ll
$(PRECOMPILED_DIR)/Time.o: $(LLVM_PLUGIN) $(PRECOMPILED_DIR)/Time.ll
	$(PRECOMPILE_LLC) -o $@ $(srcdir)/$(PRECOMPILED_DIR)/Time.ll
$(PRECOMPILED_DIR)/Int8.o: $(LLVM_PLUGIN) $(PRECOMPILED_DIR)/Int8.ll
	$(PRECOMPILE_LLC) -o $@ $(srcdir)/$(PRECOMPILED_DIR)/Int8.ll
$(PRECOMPILED_DIR)/Int16.o: $(LLVM_PLUGIN) $(PRECOMPILED_DIR)/Int16.ll
	$(PRECOMPILE_LLC) -o $@ $(srcdir)/$(PRECOMPILED_DIR)/Int16.ll
$(PRECOMPILED_DIR)/Word8VectorSlice.o: $(LLVM_PLUGIN) $(PRECOMPILED_DIR)/Word8VectorSlice.ll
	$(PRECOMPILE_LLC) -o $@ $(srcdir)/$(PRECOMPILED_DIR)/Word8VectorSlice.ll
$(PRECOMPILED_DIR)/Word8ArraySlice.o: $(LLVM_PLUGIN) $(PRECOMPILED_DIR)/Word8ArraySlice.ll
	$(PRECOMPILE_LLC) -o $@ $(srcdir)/$(PRECOMPILED_DIR)/Word8ArraySlice.ll
$(PRECOMPILED_DIR)/Array.o: $(LLVM_PLUGIN) $(PRECOMPILED_DIR)/Array.ll
	$(PRECOMPILE_LLC) -o $@ $(srcdir)/$(PRECOMPILED_DIR)/Array.ll
$(PRECOMPILED_DIR)/VectorSlice.o: $(LLVM_PLUGIN) $(PRECOMPILED_DIR)/VectorSlice.ll
	$(PRECOMPILE_LLC) -o $@ $(srcdir)/$(PRECOMPILED_DIR)/VectorSlice.ll
$(PRECOMPILED_DIR)/ArraySlice.o: $(LLVM_PLUGIN) $(PRECOMPILED_DIR)/ArraySlice.ll
	$(PRECOMPILE_LLC) -o $@ $(srcdir)/$(PRECOMPILED_DIR)/ArraySlice.ll
$(PRECOMPILED_DIR)/Word8Vector.o: $(LLVM_PLUGIN) $(PRECOMPILED_DIR)/Word8Vector.ll
	$(PRECOMPILE_LLC) -o $@ $(srcdir)/$(PRECOMPILED_DIR)/Word8Vector.ll
$(PRECOMPILED_DIR)/IO.o: $(LLVM_PLUGIN) $(PRECOMPILED_DIR)/IO.ll
	$(PRECOMPILE_LLC) -o $@ $(srcdir)/$(PRECOMPILED_DIR)/IO.ll
$(PRECOMPILED_DIR)/Word8Array.o: $(LLVM_PLUGIN) $(PRECOMPILED_DIR)/Word8Array.ll
	$(PRECOMPILE_LLC) -o $@ $(srcdir)/$(PRECOMPILED_DIR)/Word8Array.ll
$(PRECOMPILED_DIR)/SMLSharp_OSIO.o: $(LLVM_PLUGIN) $(PRECOMPILED_DIR)/SMLSharp_OSIO.ll
	$(PRECOMPILE_LLC) -o $@ $(srcdir)/$(PRECOMPILED_DIR)/SMLSharp_OSIO.ll
$(PRECOMPILED_DIR)/Bool.o: $(LLVM_PLUGIN) $(PRECOMPILED_DIR)/Bool.ll
	$(PRECOMPILE_LLC) -o $@ $(srcdir)/$(PRECOMPILED_DIR)/Bool.ll
$(PRECOMPILED_DIR)/os-path-fn.o: $(LLVM_PLUGIN) $(PRECOMPILED_DIR)/os-path-fn.ll
	$(PRECOMPILE_LLC) -o $@ $(srcdir)/$(PRECOMPILED_DIR)/os-path-fn.ll
$(PRECOMPILED_DIR)/os-path.o: $(LLVM_PLUGIN) $(PRECOMPILED_DIR)/os-path.ll
	$(PRECOMPILE_LLC) -o $@ $(srcdir)/$(PRECOMPILED_DIR)/os-path.ll
$(PRECOMPILED_DIR)/SMLSharp_OSFileSys.o: $(LLVM_PLUGIN) $(PRECOMPILED_DIR)/SMLSharp_OSFileSys.ll
	$(PRECOMPILE_LLC) -o $@ $(srcdir)/$(PRECOMPILED_DIR)/SMLSharp_OSFileSys.ll
$(PRECOMPILED_DIR)/Word32.o: $(LLVM_PLUGIN) $(PRECOMPILED_DIR)/Word32.ll
	$(PRECOMPILE_LLC) -o $@ $(srcdir)/$(PRECOMPILED_DIR)/Word32.ll
$(PRECOMPILED_DIR)/SMLSharp_OSProcess.o: $(LLVM_PLUGIN) $(PRECOMPILED_DIR)/SMLSharp_OSProcess.ll
	$(PRECOMPILE_LLC) -o $@ $(srcdir)/$(PRECOMPILED_DIR)/SMLSharp_OSProcess.ll
$(PRECOMPILED_DIR)/OS.o: $(LLVM_PLUGIN) $(PRECOMPILED_DIR)/OS.ll
	$(PRECOMPILE_LLC) -o $@ $(srcdir)/$(PRECOMPILED_DIR)/OS.ll
$(PRECOMPILED_DIR)/Option.o: $(LLVM_PLUGIN) $(PRECOMPILED_DIR)/Option.ll
	$(PRECOMPILE_LLC) -o $@ $(srcdir)/$(PRECOMPILED_DIR)/Option.ll
$(PRECOMPILED_DIR)/Word8.o: $(LLVM_PLUGIN) $(PRECOMPILED_DIR)/Word8.ll
	$(PRECOMPILE_LLC) -o $@ $(srcdir)/$(PRECOMPILED_DIR)/Word8.ll
$(PRECOMPILED_DIR)/prim-io-bin.o: $(LLVM_PLUGIN) $(PRECOMPILED_DIR)/prim-io-bin.ll
	$(PRECOMPILE_LLC) -o $@ $(srcdir)/$(PRECOMPILED_DIR)/prim-io-bin.ll
$(PRECOMPILED_DIR)/CharVectorSlice.o: $(LLVM_PLUGIN) $(PRECOMPILED_DIR)/CharVectorSlice.ll
	$(PRECOMPILE_LLC) -o $@ $(srcdir)/$(PRECOMPILED_DIR)/CharVectorSlice.ll
$(PRECOMPILED_DIR)/CharArray.o: $(LLVM_PLUGIN) $(PRECOMPILED_DIR)/CharArray.ll
	$(PRECOMPILE_LLC) -o $@ $(srcdir)/$(PRECOMPILED_DIR)/CharArray.ll
$(PRECOMPILED_DIR)/CharArraySlice.o: $(LLVM_PLUGIN) $(PRECOMPILED_DIR)/CharArraySlice.ll
	$(PRECOMPILE_LLC) -o $@ $(srcdir)/$(PRECOMPILED_DIR)/CharArraySlice.ll
$(PRECOMPILED_DIR)/Byte.o: $(LLVM_PLUGIN) $(PRECOMPILED_DIR)/Byte.ll
	$(PRECOMPILE_LLC) -o $@ $(srcdir)/$(PRECOMPILED_DIR)/Byte.ll
$(PRECOMPILED_DIR)/prim-io-text.o: $(LLVM_PLUGIN) $(PRECOMPILED_DIR)/prim-io-text.ll
	$(PRECOMPILE_LLC) -o $@ $(srcdir)/$(PRECOMPILED_DIR)/prim-io-text.ll
$(PRECOMPILED_DIR)/posix-io.o: $(LLVM_PLUGIN) $(PRECOMPILED_DIR)/posix-io.ll
	$(PRECOMPILE_LLC) -o $@ $(srcdir)/$(PRECOMPILED_DIR)/posix-io.ll
$(PRECOMPILED_DIR)/posix-bin-prim-io.o: $(LLVM_PLUGIN) $(PRECOMPILED_DIR)/posix-bin-prim-io.ll
	$(PRECOMPILE_LLC) -o $@ $(srcdir)/$(PRECOMPILED_DIR)/posix-bin-prim-io.ll
$(PRECOMPILED_DIR)/bin-io.o: $(LLVM_PLUGIN) $(PRECOMPILED_DIR)/bin-io.ll
	$(PRECOMPILE_LLC) -o $@ $(srcdir)/$(PRECOMPILED_DIR)/bin-io.ll
$(PRECOMPILED_DIR)/CommandLine.o: $(LLVM_PLUGIN) $(PRECOMPILED_DIR)/CommandLine.ll
	$(PRECOMPILE_LLC) -o $@ $(srcdir)/$(PRECOMPILED_DIR)/CommandLine.ll
$(PRECOMPILED_DIR)/Vector.o: $(LLVM_PLUGIN) $(PRECOMPILED_DIR)/Vector.ll
	$(PRECOMPILE_LLC) -o $@ $(srcdir)/$(PRECOMPILED_DIR)/Vector.ll
$(PRECOMPILED_DIR)/date.o: $(LLVM_PLUGIN) $(PRECOMPILED_DIR)/date.ll
	$(PRECOMPILE_LLC) -o $@ $(srcdir)/$(PRECOMPILED_DIR)/date.ll
$(PRECOMPILED_DIR)/ListPair.o: $(LLVM_PLUGIN) $(PRECOMPILED_DIR)/ListPair.ll
	$(PRECOMPILE_LLC) -o $@ $(srcdir)/$(PRECOMPILED_DIR)/ListPair.ll
$(PRECOMPILED_DIR)/Real32.o: $(LLVM_PLUGIN) $(PRECOMPILED_DIR)/Real32.ll
	$(PRECOMPILE_LLC) -o $@ $(srcdir)/$(PRECOMPILED_DIR)/Real32.ll
$(PRECOMPILED_DIR)/Int64.o: $(LLVM_PLUGIN) $(PRECOMPILED_DIR)/Int64.ll
	$(PRECOMPILE_LLC) -o $@ $(srcdir)/$(PRECOMPILED_DIR)/Int64.ll
$(PRECOMPILED_DIR)/posix-text-prim-io.o: $(LLVM_PLUGIN) $(PRECOMPILED_DIR)/posix-text-prim-io.ll
	$(PRECOMPILE_LLC) -o $@ $(srcdir)/$(PRECOMPILED_DIR)/posix-text-prim-io.ll
$(PRECOMPILED_DIR)/text-io.o: $(LLVM_PLUGIN) $(PRECOMPILED_DIR)/text-io.ll
	$(PRECOMPILE_LLC) -o $@ $(srcdir)/$(PRECOMPILED_DIR)/text-io.ll
$(PRECOMPILED_DIR)/Text.o: $(LLVM_PLUGIN) $(PRECOMPILED_DIR)/Text.ll
	$(PRECOMPILE_LLC) -o $@ $(srcdir)/$(PRECOMPILED_DIR)/Text.ll
$(PRECOMPILED_DIR)/Timer.o: $(LLVM_PLUGIN) $(PRECOMPILED_DIR)/Timer.ll
	$(PRECOMPILE_LLC) -o $@ $(srcdir)/$(PRECOMPILED_DIR)/Timer.ll
$(PRECOMPILED_DIR)/Word16.o: $(LLVM_PLUGIN) $(PRECOMPILED_DIR)/Word16.ll
	$(PRECOMPILE_LLC) -o $@ $(srcdir)/$(PRECOMPILED_DIR)/Word16.ll
$(PRECOMPILED_DIR)/Word64.o: $(LLVM_PLUGIN) $(PRECOMPILED_DIR)/Word64.ll
	$(PRECOMPILE_LLC) -o $@ $(srcdir)/$(PRECOMPILED_DIR)/Word64.ll
$(PRECOMPILED_DIR)/toplevel.o: $(LLVM_PLUGIN) $(PRECOMPILED_DIR)/toplevel.ll
	$(PRECOMPILE_LLC) -o $@ $(srcdir)/$(PRECOMPILED_DIR)/toplevel.ll
$(PRECOMPILED_DIR)/lib-base.o: $(LLVM_PLUGIN) $(PRECOMPILED_DIR)/lib-base.ll
	$(PRECOMPILE_LLC) -o $@ $(srcdir)/$(PRECOMPILED_DIR)/lib-base.ll
$(PRECOMPILED_DIR)/binary-map-fn.o: $(LLVM_PLUGIN) $(PRECOMPILED_DIR)/binary-map-fn.ll
	$(PRECOMPILE_LLC) -o $@ $(srcdir)/$(PRECOMPILED_DIR)/binary-map-fn.ll
$(PRECOMPILED_DIR)/SOrd.o: $(LLVM_PLUGIN) $(PRECOMPILED_DIR)/SOrd.ll
	$(PRECOMPILE_LLC) -o $@ $(srcdir)/$(PRECOMPILED_DIR)/SOrd.ll
$(PRECOMPILED_DIR)/SEnv.o: $(LLVM_PLUGIN) $(PRECOMPILED_DIR)/SEnv.ll
	$(PRECOMPILE_LLC) -o $@ $(srcdir)/$(PRECOMPILED_DIR)/SEnv.ll
$(PRECOMPILED_DIR)/parser-comb.o: $(LLVM_PLUGIN) $(PRECOMPILED_DIR)/parser-comb.ll
	$(PRECOMPILE_LLC) -o $@ $(srcdir)/$(PRECOMPILED_DIR)/parser-comb.ll
$(PRECOMPILED_DIR)/FormatExpressionTypes.o: $(LLVM_PLUGIN) $(PRECOMPILED_DIR)/FormatExpressionTypes.ll
	$(PRECOMPILE_LLC) -o $@ $(srcdir)/$(PRECOMPILED_DIR)/FormatExpressionTypes.ll
$(PRECOMPILED_DIR)/FormatExpression.o: $(LLVM_PLUGIN) $(PRECOMPILED_DIR)/FormatExpression.ll
	$(PRECOMPILE_LLC) -o $@ $(srcdir)/$(PRECOMPILED_DIR)/FormatExpression.ll
$(PRECOMPILED_DIR)/PrinterParameter.o: $(LLVM_PLUGIN) $(PRECOMPILED_DIR)/PrinterParameter.ll
	$(PRECOMPILE_LLC) -o $@ $(srcdir)/$(PRECOMPILED_DIR)/PrinterParameter.ll
$(PRECOMPILED_DIR)/AssocResolver.o: $(LLVM_PLUGIN) $(PRECOMPILED_DIR)/AssocResolver.ll
	$(PRECOMPILE_LLC) -o $@ $(srcdir)/$(PRECOMPILED_DIR)/AssocResolver.ll
$(PRECOMPILED_DIR)/PreProcessedExpression.o: $(LLVM_PLUGIN) $(PRECOMPILED_DIR)/PreProcessedExpression.ll
	$(PRECOMPILE_LLC) -o $@ $(srcdir)/$(PRECOMPILED_DIR)/PreProcessedExpression.ll
$(PRECOMPILED_DIR)/PrettyPrinter.o: $(LLVM_PLUGIN) $(PRECOMPILED_DIR)/PrettyPrinter.ll
	$(PRECOMPILE_LLC) -o $@ $(srcdir)/$(PRECOMPILED_DIR)/PrettyPrinter.ll
$(PRECOMPILED_DIR)/Truncator.o: $(LLVM_PLUGIN) $(PRECOMPILED_DIR)/Truncator.ll
	$(PRECOMPILE_LLC) -o $@ $(srcdir)/$(PRECOMPILED_DIR)/Truncator.ll
$(PRECOMPILED_DIR)/PreProcessor.o: $(LLVM_PLUGIN) $(PRECOMPILED_DIR)/PreProcessor.ll
	$(PRECOMPILE_LLC) -o $@ $(srcdir)/$(PRECOMPILED_DIR)/PreProcessor.ll
$(PRECOMPILED_DIR)/BasicFormatters.o: $(LLVM_PLUGIN) $(PRECOMPILED_DIR)/BasicFormatters.ll
	$(PRECOMPILE_LLC) -o $@ $(srcdir)/$(PRECOMPILED_DIR)/BasicFormatters.ll
$(PRECOMPILED_DIR)/PrettyPrinter2.o: $(LLVM_PLUGIN) $(PRECOMPILED_DIR)/PrettyPrinter2.ll
	$(PRECOMPILE_LLC) -o $@ $(srcdir)/$(PRECOMPILED_DIR)/PrettyPrinter2.ll
$(PRECOMPILED_DIR)/SMLFormat.o: $(LLVM_PLUGIN) $(PRECOMPILED_DIR)/SMLFormat.ll
	$(PRECOMPILE_LLC) -o $@ $(srcdir)/$(PRECOMPILED_DIR)/SMLFormat.ll
$(PRECOMPILED_DIR)/binary-set-fn.o: $(LLVM_PLUGIN) $(PRECOMPILED_DIR)/binary-set-fn.ll
	$(PRECOMPILE_LLC) -o $@ $(srcdir)/$(PRECOMPILED_DIR)/binary-set-fn.ll
$(PRECOMPILED_DIR)/SSet.o: $(LLVM_PLUGIN) $(PRECOMPILED_DIR)/SSet.ll
	$(PRECOMPILE_LLC) -o $@ $(srcdir)/$(PRECOMPILED_DIR)/SSet.ll
$(PRECOMPILED_DIR)/Filename.o: $(LLVM_PLUGIN) $(PRECOMPILED_DIR)/Filename.ll
	$(PRECOMPILE_LLC) -o $@ $(srcdir)/$(PRECOMPILED_DIR)/Filename.ll
$(PRECOMPILED_DIR)/Config.o: $(LLVM_PLUGIN) $(PRECOMPILED_DIR)/Config.ll
	$(PRECOMPILE_LLC) -o $@ $(srcdir)/$(PRECOMPILED_DIR)/Config.ll
$(PRECOMPILED_DIR)/Loc.o: $(LLVM_PLUGIN) $(PRECOMPILED_DIR)/Loc.ll
	$(PRECOMPILE_LLC) -o $@ $(srcdir)/$(PRECOMPILED_DIR)/Loc.ll
$(PRECOMPILED_DIR)/Bug.o: $(LLVM_PLUGIN) $(PRECOMPILED_DIR)/Bug.ll
	$(PRECOMPILE_LLC) -o $@ $(srcdir)/$(PRECOMPILED_DIR)/Bug.ll
$(PRECOMPILED_DIR)/PrintControl.o: $(LLVM_PLUGIN) $(PRECOMPILED_DIR)/PrintControl.ll

=== benchmark/benchmarks/Makefile ===
SMLSHARP = SMLSHARP_HEAPSIZE=32M:2G ../../src/compiler/smlsharp -B ../../src -O2
DOIT_SUFFIX =
LIBS =

#    barnes_hut/doit$(DOIT_SUFFIX) \
#    fibrepeat/doit$(DOIT_SUFFIX) \
#    mlyacc/doit$(DOIT_SUFFIX) \
#    nqueen/doit$(DOIT_SUFFIX) \
#    parallel_matrix/doit$(DOIT_SUFFIX) \
#    parallel_matrix_tail/doit$(DOIT_SUFFIX) \

all: \
    barnes_hut2/doit$(DOIT_SUFFIX) \
    boyer/doit$(DOIT_SUFFIX) \
    coresml/doit$(DOIT_SUFFIX) \
    count_graphs/doit$(DOIT_SUFFIX) \
    cpstak/doit$(DOIT_SUFFIX) \
    diviter/doit$(DOIT_SUFFIX) \
    divrec/doit$(DOIT_SUFFIX) \
    fft/doit$(DOIT_SUFFIX) \
    gcbench/doit$(DOIT_SUFFIX) \
    knuth_bendix/doit$(DOIT_SUFFIX) \
    lexgen/doit$(DOIT_SUFFIX) \
    life/doit$(DOIT_SUFFIX) \
    logic/doit$(DOIT_SUFFIX) \
    mandelbrot/doit$(DOIT_SUFFIX) \
    smlyacc/doit$(DOIT_SUFFIX) \
    nucleic/doit$(DOIT_SUFFIX) \
    perm9/doit$(DOIT_SUFFIX) \
    puzzle/doit$(DOIT_SUFFIX) \
    ratio_regions/doit$(DOIT_SUFFIX) \
    ray/doit$(DOIT_SUFFIX) \
    simple/doit$(DOIT_SUFFIX) \
    smlsharp/doit$(DOIT_SUFFIX) \
    tsp/doit$(DOIT_SUFFIX) \
    vliw/doit$(DOIT_SUFFIX)

.SUFFIXES: .o .smi .sml

.sml.o:
	$(SMLSHARP) -c -o $@ $<

include link.mk
include depend.mk

=== sample/database-cgi/Makefile ===
SMLSHARP = smlsharp

database-cgi: load.smi cgi.o cgimain.o load.o pages.o try.o
	$(SMLSHARP) -o $@ load.smi
cgi.o: cgi.sml cgi.smi
	$(SMLSHARP) -c -o $@ cgi.sml
cgimain.o: cgimain.sml cgi.smi pages.smi cgimain.smi
	$(SMLSHARP) -c -o $@ cgimain.sml
load.o: load.sml load.smi cgimain.smi cgi.smi pages.smi try.smi
	$(SMLSHARP) -c -o $@ load.sml
pages.o: pages.sml cgi.smi try.smi pages.smi
	$(SMLSHARP) -c -o $@ pages.sml
try.o: try.sml try.smi
	$(SMLSHARP) -c -o $@ try.sml

clean:
	-rm -f database-cgi cgi.o cgimain.o load.o pages.o try.o

=== sample/database/Makefile ===
SMLSHARP = smlsharp

all: sample1

sample1: sample1.sml sample1.smi
	$(SMLSHARP) -o $@ sample1.sml
sample2: sample2.sml sample2.smi
	$(SMLSHARP) -o $@ sample2.sml

clean:
	-rm -f sample1

=== sample/qsort/Makefile ===
SMLSHARP = smlsharp

qsort: qsort.sml
	$(SMLSHARP) -o $@ qsort.sml

clean:
	-rm -f qsort

=== benchmark/benchmarks/realtime/Makefile ===
#SMLSHARP = ../../../src/compiler/smlsharp -B../../../../../smlsharp_concurrentgc/smlsharp/src -dinsertCheckGC=yes
SMLSHARP = ../../../src/compiler/smlsharp -B../../../src -dinsertCheckGC=yes
CC = gcc -m32

realtime: top.smi top.o main.o gettime.o clock_gettime.o pthread.o fft.o count_graphs.o gcbench.o
	$(SMLSHARP) -o $@ top.smi $(LIBS) clock_gettime.o -lrt

top.o : top.sml top.smi main.smi
	$(SMLSHARP) -c -o $@ top.sml
main.o : main.sml main.smi gettime.smi pthread.smi fft.smi count_graphs.smi
	$(SMLSHARP) -c -o $@ main.sml
gettime.o : gettime.sml gettime.smi clock_gettime.c
	$(SMLSHARP) -c -o $@ gettime.sml
clock_gettime.o : clock_gettime.c
	$(CC) -c -o $@ clock_gettime.c
pthread.o : pthread.sml pthread.smi 
	$(SMLSHARP) -c -o $@ pthread.sml
fft.o : fft.sml fft.smi
	$(SMLSHARP) -c -o $@ fft.sml
gcbench.o : gcbench.sml gcbench.smi
	$(SMLSHARP) -c -o $@ gcbench.sml
count_graphs.o : count_graphs.sml count_graphs.smi
	$(SMLSHARP) -c -o $@ count_graphs.sml


clean:
	-rm -f realtime top.o main.o gettime.o clock_gettime.o pthread.o fft.o count_graph.o

=== benchmark/benchmarks_parallel/parser/Makefile ===
SMLSHARP = ../../../src/compiler/smlsharp -B ../../../src
SMLFLAGS = -O2
CC = cc
CFLAGS = -O2

all: main_seq main_pth main_myth

clean:
	rm -f main_seq main_pth main_myth
	rm -f stdio.o files.o parse.o main_seq.o main_pth.o main_myth.o incr.o

main_seq: files.o stdio.o parse.o main_seq.o
	$(SMLSHARP) -o $@ main_seq.smi
main_pth: files.o stdio.o parse.o main_pth.o incr.o
	$(SMLSHARP) -o $@ main_pth.smi incr.o
main_myth: files.o stdio.o parse.o main_myth.o
	$(SMLSHARP) -o $@ main_myth.smi
stdio.o: stdio.sml stdio.smi
	$(SMLSHARP) $(SMLFLAGS) -c -o $@ stdio.sml
files.o: files.sml files.smi
	$(SMLSHARP) $(SMLFLAGS) -c -o $@ files.sml
parse.o: parse.sml stdio.smi parse.smi
	$(SMLSHARP) $(SMLFLAGS) -c -o $@ parse.sml
main_seq.o: main_seq.sml files.smi parse.smi main_seq.smi
	$(SMLSHARP) $(SMLFLAGS) -c -o $@ main_seq.sml
main_pth.o: main_pth.sml files.smi parse.smi main_pth.smi
	$(SMLSHARP) $(SMLFLAGS) -c -o $@ main_pth.sml
main_myth.o: main_myth.sml files.smi parse.smi main_myth.smi
	$(SMLSHARP) $(SMLFLAGS) -c -o $@ main_myth.sml
incr.o: incr.c
	$(CC) $(CFLAGS) -c -o $@ incr.c


main_seq35: files.o stdio.o parse.o main_seq.o ../smlsharp-3.5.0/src/runtime/libsmlsharp.a
	$(SMLSHARP) -o $@ -nostdlib ../smlsharp-3.5.0/src/runtime/main.o main_seq.smi ../smlsharp-3.5.0/src/runtime/libsmlsharp.a
main_pth35: files.o stdio.o parse.o main_pth.o incr.o ../smlsharp-3.5.0/src/runtime/libsmlsharp.a
	$(SMLSHARP) -o $@ -nostdlib ../smlsharp-3.5.0/src/runtime/main.o main_pth.smi incr.o ../smlsharp-3.5.0/src/runtime/libsmlsharp.a

=== src/smlref/main/Makefile ===
SMLSHARP = ../../../src/compiler/smlsharp -B../../../src
SMLFORMAT = smlformat
SMLFLAGS = -O2
LIBS =

.SUFFIXES: .o .sml .smi .sig .ppg

all: SMLRef TestMain GenReuireDecls

DBSchema.smi: ../../compiler/compilePhases/analyzefiles/main/DBSchema.smi
	cp ../../compiler/compilePhases/analyzefiles/main/DBSchema.smi DBSchema.smi 

DBSchema.sml: ../../compiler/compilePhases/analyzefiles/main/DBSchema.sml
	cp ../../compiler/compilePhases/analyzefiles/main/DBSchema.sml DBSchema.sml

nestedMap.ppg.sml:  nestedMap.ppg  nestedMap.ppg.smi
	$(SMLFORMAT)  --output=$@ --input nestedMap.ppg

SMLRef: DBSchema.smi Config.smi Log.smi RefDBAccess.smi SMLRef.smi DBSchema.o \
 Config.o Log.o RefDBAccess.o SMLRef.o
	$(SMLSHARP) $(LDFLAGS) -o SMLRef SMLRef.smi $(LIBS)
DBSchema.o: DBSchema.sml DBSchema.smi
	$(SMLSHARP) $(SMLFLAGS) -o DBSchema.o -c DBSchema.sml
Config.o: Config.sml DBSchema.smi Config.smi
	$(SMLSHARP) $(SMLFLAGS) -o Config.o -c Config.sml
Log.o: Log.sml DBSchema.smi Config.smi Log.smi
	$(SMLSHARP) $(SMLFLAGS) -o Log.o -c Log.sml
RefDBAccess.o: RefDBAccess.sml DBSchema.smi Config.smi Log.smi RefDBAccess.smi
	$(SMLSHARP) $(SMLFLAGS) -o RefDBAccess.o -c RefDBAccess.sml
SMLRef.o: SMLRef.sml DBSchema.smi Config.smi Log.smi RefDBAccess.smi SMLRef.smi
	$(SMLSHARP) $(SMLFLAGS) -o SMLRef.o -c SMLRef.sml

GenReuireDecls: DBSchema.smi Config.smi ProcessRequireFile.smi \
 GenReuireDecls.smi DBSchema.o Config.o ProcessRequireFile.o GenReuireDecls.o
	$(SMLSHARP) $(LDFLAGS) -o GenReuireDecls GenReuireDecls.smi $(LIBS)
ProcessRequireFile.o: ProcessRequireFile.sml DBSchema.smi Config.smi \
 ProcessRequireFile.smi
	$(SMLSHARP) $(SMLFLAGS) -o ProcessRequireFile.o -c \
 ProcessRequireFile.sml
GenReuireDecls.o: GenReuireDecls.sml DBSchema.smi Config.smi \
 ProcessRequireFile.smi GenReuireDecls.smi
	$(SMLSHARP) $(SMLFLAGS) -o GenReuireDecls.o -c GenReuireDecls.sml

TestMain: DBSchema.smi Config.smi IntStringMap.smi IntIntStringMap.smi \
 BasicData.smi nestedMap.ppg.smi TestMain.smi DBSchema.o Config.o \
 IntStringMap.o IntIntStringMap.o IntIntIntStringMap.o BasicData.o nestedMap.ppg.o TestMain.o
	$(SMLSHARP) $(LDFLAGS) -o TestMain TestMain.smi $(LIBS)
IntStringMap.o: IntStringMap.sml IntStringMap.smi
	$(SMLSHARP) $(SMLFLAGS) -o IntStringMap.o -c IntStringMap.sml
IntIntStringMap.o: IntIntStringMap.sml IntIntStringMap.smi
	$(SMLSHARP) $(SMLFLAGS) -o IntIntStringMap.o -c IntIntStringMap.sml
IntIntIntStringMap.o: IntIntIntStringMap.sml IntIntIntStringMap.smi
	$(SMLSHARP) $(SMLFLAGS) -o IntIntIntStringMap.o -c IntIntIntStringMap.sml
BasicData.o: BasicData.sml DBSchema.smi Config.smi IntStringMap.smi \
 IntIntStringMap.smi IntIntIntStringMap.smi BasicData.smi
	$(SMLSHARP) $(SMLFLAGS) -o BasicData.o -c BasicData.sml
nestedMap.ppg.o: nestedMap.ppg.sml nestedMap.ppg.smi
	$(SMLSHARP) $(SMLFLAGS) -o nestedMap.ppg.o -c nestedMap.ppg.sml
TestMain.o: TestMain.sml DBSchema.smi Config.smi IntStringMap.smi \
 IntIntStringMap.smi BasicData.smi nestedMap.ppg.smi TestMain.smi
	$(SMLSHARP) $(SMLFLAGS) -o TestMain.o -c TestMain.sml

clean: 
	rm -f SMLRef GenReuireDecls BasicData.o \
 Config.o DBSchema.o DataUtils.o \
 GenReuireDecls.o IntStringMap.o Log.o IntIntStringMap.o Log.o ProcessRequireFile.o \
 RefDBAccess.o SMLRef.o TestMain.o nestedMap.ppg.o nestedMap.ppg.sml

=== src/smlunit/example/Makefile ===
SMLSHARP_ENV = SMLSHARP_HEAPSIZE=128M:1G
SMLSHARP = smlsharp
SMLFLAGS = -O2
ALLOBJECTS = Main.o TestDictionary.o Dictionary.o

testExec: $(ALLOBJECTS)
	$(SMLSHARP_ENV) $(SMLSHARP) $(SMLFLAGS) -o testExec Main.smi

Dictionary.o: Dictionary.sml Dictionary.smi DICTIONARY.sig Dictionary.smi

Main.o: Main.sml Main.smi DICTIONARY.sig Dictionary.smi TestDictionary.smi \
 Main.smi

TestDictionary.o: TestDictionary.sml TestDictionary.smi DICTIONARY.sig \
 Dictionary.smi TestDictionary.smi

.sml.o:
	$(SMLSHARP_ENV) $(SMLSHARP) $(SMLFLAGS) -c -o $@ $<

.SUFFIXES: .sml

clean: PHONY
	rm -f $(ALLOBJECTS) testExec

PHONY:

=== src/smlunit/basis/test/Makefile ===
SMLSHARP_ENV = SMLSHARP_HEAPSIZE=32M:2G
SMLSHARP = smlsharp
# SMLFLAGS = -O2

ALLOBJECTS = Main.o TestMain.o TestOptionalModules_SMLSharp.o IntInf101.o IntInf001.o \
 TestRequiredModules.o Word8VectorSlice001.o Word8VectorSlice101.o \
 Word8Vector101.o Word8Vector001.o Word8ArraySlice101.o Word8ArraySlice001.o \
 Word8Array101.o Word8Array001.o Word8001.o Word001.o VectorSlice101.o \
 VectorSlice001.o Vector101.o Vector001.o Time001.o Substring001.o String001.o \
 StringCvt001.o Real001.o Position001.o Option001.o Math001.o ListPair001.o \
 List001.o LargeWord001.o UnsignedInteger001.o LargeInt001.o Int001.o \
 SignedInteger001.o IEEEReal001.o General001.o Date001.o CharVectorSlice101.o \
 CharVectorSlice001.o ImmutableSequenceSlice001.o CharVector101.o \
 CharVector001.o ImmutableSequence001.o CharArraySlice101.o \
 CharArraySlice001.o CharArray101.o CharArray001.o Char001.o Byte001.o \
 Bool001.o ArraySlice101.o SequenceSlice101.o ArraySlice001.o \
 MutableSequenceSlice001.o Array101.o Sequence101.o Array001.o \
 MutableSequence001.o ../../src/main/SMLUnit.o \
 ../../src/main/TextUITestRunner.o ../../src/main/Test.o \
 ../../src/main/Assert.o

testExec : $(ALLOBJECTS)
	$(SMLSHARP_ENV) $(SMLSHARP) $(SMLFLAGS) -o testExec Main.smi

clean: PHONY
	rm -f $(ALLOBJECTS) testExec

PHONY: # force to rebuild

.sml.o:
	$(SMLSHARP_ENV) $(SMLSHARP) $(SMLFLAGS) -c -o $@ $<

.SUFFIXES: .sml

Array001.o: Array001.sml Array001.smi ../../src/main/ASSERT.sig \
 ../../src/main/Assert.smi ../../src/main/TEST.sig ../../src/main/Test.smi \
 ../../src/main/TESTRUNNER.sig ../../src/main/TextUITestRunner.smi \
 ../../src/main/SMLUNIT.sig ../../src/main/SMLUnit.smi SEQUENCE.sig \
 MUTABLE_SEQUENCE.sig MutableSequence001.smi Array001.smi
Array101.o: Array101.sml Array101.smi ../../src/main/ASSERT.sig \
 ../../src/main/Assert.smi ../../src/main/TEST.sig ../../src/main/Test.smi \
 ../../src/main/TESTRUNNER.sig ../../src/main/TextUITestRunner.smi \
 ../../src/main/SMLUNIT.sig ../../src/main/SMLUnit.smi SEQUENCE.sig \
 Sequence101.smi Array101.smi
Array2001.o: Array2001.sml Array2001.smi SEQUENCE.sig Sequence101.smi \
 Array2001.smi
ArraySlice001.o: ArraySlice001.sml ArraySlice001.smi SEQUENCE_SLICE.sig \
 MUTABLE_SEQUENCE_SLICE.sig MutableSequenceSlice001.smi ArraySlice001.smi
ArraySlice101.o: ArraySlice101.sml ArraySlice101.smi SEQUENCE.sig \
 SEQUENCE_SLICE.sig SequenceSlice101.smi ArraySlice101.smi
Bool001.o: Bool001.sml Bool001.smi Bool001.smi
Byte001.o: Byte001.sml Byte001.smi Byte001.smi
Char001.o: Char001.sml Char001.smi Char001.smi
CharArray001.o: CharArray001.sml CharArray001.smi SEQUENCE.sig \
 MUTABLE_SEQUENCE.sig MutableSequence001.smi CharArray001.smi
CharArray101.o: CharArray101.sml CharArray101.smi SEQUENCE.sig Sequence101.smi \
 CharArray101.smi
CharArray2001.o: CharArray2001.sml CharArray2001.smi SEQUENCE.sig \
 Sequence101.smi CharArray2001.smi
CharArraySlice001.o: CharArraySlice001.sml CharArraySlice001.smi \
 SEQUENCE_SLICE.sig MUTABLE_SEQUENCE_SLICE.sig MutableSequenceSlice001.smi \
 CharArraySlice001.smi
CharArraySlice101.o: CharArraySlice101.sml CharArraySlice101.smi SEQUENCE.sig \
 SEQUENCE_SLICE.sig SequenceSlice101.smi CharArraySlice101.smi
CharVector001.o: CharVector001.sml CharVector001.smi SEQUENCE.sig \
 IMMUTABLE_SEQUENCE.sig ImmutableSequence001.smi CharVector001.smi
CharVector101.o: CharVector101.sml CharVector101.smi SEQUENCE.sig \
 Sequence101.smi CharVector101.smi
CharVectorSlice001.o: CharVectorSlice001.sml CharVectorSlice001.smi \
 SEQUENCE_SLICE.sig IMMUTABLE_SEQUENCE_SLICE.sig ImmutableSequenceSlice001.smi \
 CharVectorSlice001.smi
CharVectorSlice101.o: CharVectorSlice101.sml CharVectorSlice101.smi \
 SEQUENCE.sig SEQUENCE_SLICE.sig SequenceSlice101.smi CharVectorSlice101.smi
Date001.o: Date001.sml Date001.smi Date001.smi
General001.o: General001.sml General001.smi General001.smi
IEEEReal001.o: IEEEReal001.sml IEEEReal001.smi IEEEReal001.smi
ImmutableSequence001.o: ImmutableSequence001.sml ImmutableSequence001.smi \
 SEQUENCE.sig IMMUTABLE_SEQUENCE.sig ImmutableSequence001.smi
ImmutableSequenceSlice001.o: ImmutableSequenceSlice001.sml \
 ImmutableSequenceSlice001.smi SEQUENCE_SLICE.sig IMMUTABLE_SEQUENCE_SLICE.sig \
 ImmutableSequenceSlice001.smi
Int001.o: Int001.sml Int001.smi SignedInteger001.smi Int001.smi
IntInf001.o: IntInf001.sml IntInf001.smi SignedInteger001.smi IntInf001.smi
IntInf101.o: IntInf101.sml IntInf101.smi IntInf101.smi
LargeInt001.o: LargeInt001.sml LargeInt001.smi SignedInteger001.smi \
 LargeInt001.smi
LargeWord001.o: LargeWord001.sml LargeWord001.smi UnsignedInteger001.smi \
 LargeWord001.smi
List001.o: List001.sml List001.smi List001.smi
ListPair001.o: ListPair001.sml ListPair001.smi ListPair001.smi
Main.o: Main.sml Main.smi ../../src/main/ASSERT.sig ../../src/main/Assert.smi \
 ../../src/main/TEST.sig ../../src/main/Test.smi ../../src/main/TESTRUNNER.sig \
 ../../src/main/TextUITestRunner.smi ../../src/main/SMLUNIT.sig \
 ../../src/main/SMLUnit.smi SEQUENCE.sig MUTABLE_SEQUENCE.sig \
 MutableSequence001.smi Array001.smi Sequence101.smi Array101.smi \
 SEQUENCE_SLICE.sig MUTABLE_SEQUENCE_SLICE.sig MutableSequenceSlice001.smi \
 ArraySlice001.smi SequenceSlice101.smi ArraySlice101.smi Bool001.smi \
 Byte001.smi Char001.smi CharArray001.smi CharArray101.smi \
 CharArraySlice001.smi CharArraySlice101.smi IMMUTABLE_SEQUENCE.sig \
 ImmutableSequence001.smi CharVector001.smi CharVector101.smi \
 IMMUTABLE_SEQUENCE_SLICE.sig ImmutableSequenceSlice001.smi \
 CharVectorSlice001.smi CharVectorSlice101.smi Date001.smi General001.smi \
 IEEEReal001.smi SignedInteger001.smi Int001.smi LargeInt001.smi \
 UnsignedInteger001.smi LargeWord001.smi List001.smi ListPair001.smi \
 Math001.smi Option001.smi Position001.smi Real001.smi StringCvt001.smi \
 String001.smi Substring001.smi Time001.smi Vector001.smi Vector101.smi \
 VectorSlice001.smi VectorSlice101.smi Word001.smi Word8001.smi \
 Word8Array001.smi Word8Array101.smi Word8ArraySlice001.smi \
 Word8ArraySlice101.smi Word8Vector001.smi Word8Vector101.smi \
 Word8VectorSlice101.smi Word8VectorSlice001.smi TestRequiredModules.smi \
 IntInf001.smi IntInf101.smi TestOptionalModules_SMLSharp.smi TestMain.smi \
 Main.smi
Math001.o: Math001.sml Math001.smi Math001.smi
Mutable2DSequence001.o: Mutable2DSequence001.sml Mutable2DSequence001.smi \
 SEQUENCE.sig MUTABLE_2D_SEQUENCE.sig Mutable2DSequence001.smi
MutableSequence001.o: MutableSequence001.sml MutableSequence001.smi \
 SEQUENCE.sig MUTABLE_SEQUENCE.sig MutableSequence001.smi
MutableSequenceSlice001.o: MutableSequenceSlice001.sml \
 MutableSequenceSlice001.smi SEQUENCE_SLICE.sig MUTABLE_SEQUENCE_SLICE.sig \
 MutableSequenceSlice001.smi
Option001.o: Option001.sml Option001.smi Option001.smi
Position001.o: Position001.sml Position001.smi SignedInteger001.smi \
 Position001.smi
Real001.o: Real001.sml Real001.smi Real001.smi
RealArray001.o: RealArray001.sml RealArray001.smi SEQUENCE.sig \
 MUTABLE_SEQUENCE.sig MutableSequence001.smi RealArray001.smi
RealArray101.o: RealArray101.sml RealArray101.smi SEQUENCE.sig Sequence101.smi \
 RealArray101.smi
RealVector001.o: RealVector001.sml RealVector001.smi SEQUENCE.sig \
 MUTABLE_SEQUENCE.sig MutableSequence001.smi RealVector001.smi
RealVector101.o: RealVector101.sml RealVector101.smi SEQUENCE.sig \
 Sequence101.smi RealVector101.smi
Sequence101.o: Sequence101.sml Sequence101.smi SEQUENCE.sig Sequence101.smi
SequenceSlice101.o: SequenceSlice101.sml SequenceSlice101.smi SEQUENCE.sig \
 SEQUENCE_SLICE.sig SequenceSlice101.smi
SignedInteger001.o: SignedInteger001.sml SignedInteger001.smi \
 SignedInteger001.smi
String001.o: String001.sml String001.smi String001.smi
StringCvt001.o: StringCvt001.sml StringCvt001.smi StringCvt001.smi
Substring001.o: Substring001.sml Substring001.smi Substring001.smi
TestMain.o: TestMain.sml TestMain.smi ../../src/main/ASSERT.sig \
 ../../src/main/Assert.smi ../../src/main/TEST.sig ../../src/main/Test.smi \
 ../../src/main/TESTRUNNER.sig ../../src/main/TextUITestRunner.smi \
 ../../src/main/SMLUNIT.sig ../../src/main/SMLUnit.smi SEQUENCE.sig \
 MUTABLE_SEQUENCE.sig MutableSequence001.smi Array001.smi Sequence101.smi \
 Array101.smi SEQUENCE_SLICE.sig MUTABLE_SEQUENCE_SLICE.sig \
 MutableSequenceSlice001.smi ArraySlice001.smi SequenceSlice101.smi \
 ArraySlice101.smi Bool001.smi Byte001.smi Char001.smi CharArray001.smi \
 CharArray101.smi CharArraySlice001.smi CharArraySlice101.smi \
 IMMUTABLE_SEQUENCE.sig ImmutableSequence001.smi CharVector001.smi \
 CharVector101.smi IMMUTABLE_SEQUENCE_SLICE.sig ImmutableSequenceSlice001.smi \
 CharVectorSlice001.smi CharVectorSlice101.smi Date001.smi General001.smi \
 IEEEReal001.smi SignedInteger001.smi Int001.smi LargeInt001.smi \
 UnsignedInteger001.smi LargeWord001.smi List001.smi ListPair001.smi \
 Math001.smi Option001.smi Position001.smi Real001.smi StringCvt001.smi \
 String001.smi Substring001.smi Time001.smi Vector001.smi Vector101.smi \
 VectorSlice001.smi VectorSlice101.smi Word001.smi Word8001.smi \
 Word8Array001.smi Word8Array101.smi Word8ArraySlice001.smi \
 Word8ArraySlice101.smi Word8Vector001.smi Word8Vector101.smi \
 Word8VectorSlice101.smi Word8VectorSlice001.smi TestRequiredModules.smi \
 IntInf001.smi IntInf101.smi TestOptionalModules_SMLSharp.smi TestMain.smi
TestOptionalModules_MLton.o: TestOptionalModules_MLton.sml
TestOptionalModules_SMLNJ.o: TestOptionalModules_SMLNJ.sml
TestOptionalModules_SMLSharp.o: TestOptionalModules_SMLSharp.sml \
 TestOptionalModules_SMLSharp.smi SignedInteger001.smi IntInf001.smi \
 IntInf101.smi TestOptionalModules_SMLSharp.smi
TestRequiredModules.o: TestRequiredModules.sml TestRequiredModules.smi \
 ../../src/main/ASSERT.sig ../../src/main/Assert.smi ../../src/main/TEST.sig \
 ../../src/main/Test.smi ../../src/main/TESTRUNNER.sig \
 ../../src/main/TextUITestRunner.smi ../../src/main/SMLUNIT.sig \
 ../../src/main/SMLUnit.smi SEQUENCE.sig MUTABLE_SEQUENCE.sig \
 MutableSequence001.smi Array001.smi Sequence101.smi Array101.smi \
 SEQUENCE_SLICE.sig MUTABLE_SEQUENCE_SLICE.sig MutableSequenceSlice001.smi \
 ArraySlice001.smi SequenceSlice101.smi ArraySlice101.smi Bool001.smi \
 Byte001.smi Char001.smi CharArray001.smi CharArray101.smi \
 CharArraySlice001.smi CharArraySlice101.smi IMMUTABLE_SEQUENCE.sig \
 ImmutableSequence001.smi CharVector001.smi CharVector101.smi \
 IMMUTABLE_SEQUENCE_SLICE.sig ImmutableSequenceSlice001.smi \
 CharVectorSlice001.smi CharVectorSlice101.smi Date001.smi General001.smi \
 IEEEReal001.smi SignedInteger001.smi Int001.smi LargeInt001.smi \
 UnsignedInteger001.smi LargeWord001.smi List001.smi ListPair001.smi \
 Math001.smi Option001.smi Position001.smi Real001.smi StringCvt001.smi \
 String001.smi Substring001.smi Time001.smi Vector001.smi Vector101.smi \
 VectorSlice001.smi VectorSlice101.smi Word001.smi Word8001.smi \
 Word8Array001.smi Word8Array101.smi Word8ArraySlice001.smi \
 Word8ArraySlice101.smi Word8Vector001.smi Word8Vector101.smi \
 Word8VectorSlice101.smi Word8VectorSlice001.smi TestRequiredModules.smi
TestTest.o: TestTest.sml TestTest.smi Bool001.smi TestTest.smi
Time001.o: Time001.sml Time001.smi Time001.smi
UnsignedInteger001.o: UnsignedInteger001.sml UnsignedInteger001.smi \
 UnsignedInteger001.smi
Vector001.o: Vector001.sml Vector001.smi SEQUENCE.sig IMMUTABLE_SEQUENCE.sig \
 ImmutableSequence001.smi Vector001.smi
Vector101.o: Vector101.sml Vector101.smi SEQUENCE.sig Sequence101.smi \
 Vector101.smi
VectorSlice001.o: VectorSlice001.sml VectorSlice001.smi SEQUENCE_SLICE.sig \
 IMMUTABLE_SEQUENCE_SLICE.sig ImmutableSequenceSlice001.smi VectorSlice001.smi
VectorSlice101.o: VectorSlice101.sml VectorSlice101.smi SEQUENCE.sig \
 SEQUENCE_SLICE.sig SequenceSlice101.smi VectorSlice101.smi
Word001.o: Word001.sml Word001.smi UnsignedInteger001.smi Word001.smi
Word8001.o: Word8001.sml Word8001.smi UnsignedInteger001.smi Word8001.smi
Word8Array001.o: Word8Array001.sml Word8Array001.smi SEQUENCE.sig \
 MUTABLE_SEQUENCE.sig MutableSequence001.smi Word8Array001.smi

=== debian/changelog ===
smlsharp (4.1.0-1) unstable; urgency=medium

  * New upstream release.
  * d/control:
    - Bump Standards-Version to 4.7.0 (no change)
    - Fix typo from extentions to extensions in description.
  * d/patches
    - Remove unnecessary patch
  * d/copyright
    - Update copyright year.
    - Remove superfluous file pattern.

 -- Nobuhiro Iwamatsu <iwamatsu@debian.org>  Wed, 05 Feb 2025 17:55:08 +0900

smlsharp (4.0.0+git20211227.5af5945b-2) unstable; urgency=medium

  * Fix build with LLVM 14.0 (Closes: #1016269)
    Add d/patches/0001-Add-support-LLVM-14.0.patch.

 -- Nobuhiro Iwamatsu <iwamatsu@debian.org>  Thu, 04 Aug 2022 15:19:35 +0900

=== debian/control ===
Source: smlsharp
Section: devel
Priority: optional
Maintainer: Nobuhiro Iwamatsu <iwamatsu@debian.org>
Build-Depends: debhelper-compat (= 13),
               libgmp-dev,
               llvm-dev,
               libmassivethreads-dev
Standards-Version: 4.7.0
Rules-Requires-Root: no
Homepage: https://smlsharp.github.io
Vcs-Git: https://salsa.debian.org/debian/smlsharp.git
Vcs-Browser: https://salsa.debian.org/debian/smlsharp

Package: smlsharp
Architecture: amd64
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: Standard ML compiler with practical extensions
 SML# is a variant of Standard ML programming
 language with several practical extensions,
 including seamless interoperability with C,
 integration with SQL, and separate compilation.

=== debian/rules ===
#!/usr/bin/make -f

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

export DEB_BUILD_MAINT_OPTIONS = hardening=+all
DPKG_EXPORT_BUILDFLAGS = 1
include /usr/share/dpkg/buildflags.mk

%:
	dh $@

override_dh_auto_configure:
	CFLAGS="$(CFLAGS)" LDFLAGS="$(LDFLAGS)" \
	./configure --prefix=/usr

override_dh_auto_build:
	dh_auto_build -- stage
	dh_auto_build -- all

## smlsharp 4.2.0

=== sample/spectrum/Makefile ===
SMLSHARP = smlsharp
LIBS = -lgsl -Wl,-framework,OpenGL -Wl,-framework,GLUT  # for Mac OS X
#LIBS = -lgsl -L/usr/X11R6/lib -lgl -lglu -lglut

all: spectrum sine

sine: sine.c
	$(CC) $(CFLAGS) -o $@ sine.c -lm

spectrum: load.smi load.o ../glut/libglut.o libm.o libgsl.o spectrum.o \
          libc.o input_plain.o display_glut.o
	$(SMLSHARP) -o $@ load.smi $(LIBS)
clean:
	-rm -f spectrum load.o ../glut/libglut.o libm.o libgsl.o spectrum.o \
	       libc.o input_plain.o display_glut.o
	-rm -f sine

.SUFFIXES: .o .c .sml

.sml.o:
	$(SMLSHARP) -c -o $@ $<

display_curses.o: display_curses.sml libc.smi libcurses.smi input.sig \
  input_plain.smi libm.smi libgsl.smi spectrum.smi display.sig \
  display_curses.smi
display_glut.o: display_glut.sml ../glut/libglut.smi libm.smi libgsl.smi \
  spectrum.smi libc.smi input.sig input_plain.smi display.sig display_glut.smi
display_text.o: display_text.sml libc.smi input.sig input_plain.smi libm.smi \
  libgsl.smi spectrum.smi display.sig display_text.smi
input_plain.o: input_plain.sml libc.smi input.sig input_plain.smi
libc.o: libc.sml libc.smi
libcurses.o: libcurses.sml libcurses.smi
libgsl.o: libgsl.sml libgsl.smi
libm.o: libm.sml libm.smi
load.o: load.sml ../glut/libglut.smi libm.smi libgsl.smi spectrum.smi \
  libc.smi input.sig input_plain.smi display.sig display_glut.smi load.smi
spectrum.o: spectrum.sml libm.smi libgsl.smi spectrum.smi
../glut/libglut.o: ../glut/libglut.sml ../glut/libglut.smi

=== src/compiler/extensions/reflection/test/Makefile ===
MLYACC = ../../../ml-yacc/smlyacc
MLLEX = ../../../ml-lex/smllex
SMLFORMAT = ../../../smlformat/smlformat
# SMLSHARP = ../../../compiler/smlsharp
SMLSHARP = smlsharp
SRCDIR = ../main

.SUFFIXES: .c .h .o .a .sml .ppg .ppg.sml .lex .grm .lex.sml .grm.sml

.sml.o:
	$(SMLSHARP) -B../../../. -c -o $@ $<

.ppg.ppg.sml:
	$(SMLFORMAT) --output=$@ $<


allTest: allTest.o  TestValuePrinting.o 
	$(SMLSHARP) -o allTest -B../../../. allTest.smi

TestValuePrinting: TestValuePrinting.o $(SRCDIR)/ReifiedTy.ppg.o $(SRCDIR)/ReifiedTy.ppg.smi $(SRCDIR)/ReifiedTerm.ppg.o $(SRCDIR)/ReifiedTerm.ppg.smi $(SRCDIR)/ReifyTerm.o $(SRCDIR)/ReifyTerm.smi
	$(SMLSHARP) -o TestValuePrinting -B../../../. TestValuePrinting.smi

$(SRCDIR)/ReifiedTy.ppg.sml: $(SRCDIR)/ReifiedTy.ppg $(SRCDIR)/ReifiedTy.ppg.smi

$(SRCDIR)/ReifiedTy.ppg.o: $(SRCDIR)/ReifiedTy.ppg.sml $(SRCDIR)/ReifiedTy.ppg.smi

clean:
	rm -f ./*.o TestReify TestReifyTy allTest TestTyToReifinedTy

=== debian/changelog ===
smlsharp (4.2.0-1~exp1) experimental; urgency=medium

  * New upstream release.
  * d/control: Bump Standards-Version to 4.7.2 (no change).
  * d/rules: Added the function to create RELEASE files.
  * d/smlsharp.manpages: Switch to upstream's manpage.

 -- Nobuhiro Iwamatsu <iwamatsu@debian.org>  Wed, 25 Jun 2025 15:07:51 +0900

=== debian/control ===
--- 
+++ 
@@ -6,7 +6,7 @@
                libgmp-dev,
                llvm-dev,
                libmassivethreads-dev
-Standards-Version: 4.7.0
+Standards-Version: 4.7.2
 Rules-Requires-Root: no
 Homepage: https://smlsharp.github.io
 Vcs-Git: https://salsa.debian.org/debian/smlsharp.git

=== debian/rules ===
--- 
+++ 
@@ -11,6 +11,7 @@
 	dh $@
 
 override_dh_auto_configure:
+	dpkg-parsechangelog -S Version | sed 's/-.*//;s/~/-/' > RELEASE
 	CFLAGS="$(CFLAGS)" LDFLAGS="$(LDFLAGS)" \
 	./configure --prefix=/usr

=== debian/watch ===
version=4

opts=filenamemangle=s/.*\/v(\d\S+)\.tar\.gz/smlsharp-$1\.tar\.gz/ https://github.com/smlsharp/smlsharp/tags .*\/v(\d\S+)\.tar\.gz
